#
# spec file for package ZoneMinder
#
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to monex@liquid-co.de
#

# norootforbuild

%bcond_with mp_package
%bcond_without debug 

%if %{with mp_package}
Name:           ZoneMinder-MP
%else
Name:           ZoneMinder
%endif
BuildRequires:  apache2 php5 apache2-mod_php5 php5-mysql php5-bz2 php5-gd php5-zlib php5-iconv php5-mcrypt php5-sockets pcre-devel libjpeg-devel gcc gcc-c++ perl perl-Archive-Tar perl-Archive-Zip perl-DBI perl-DBD-mysql perl-Crypt-SSLeay perl-XML-Parser perl-libwww-perl perl-Date-Manip perl-MIME-Lite perl-MIME-tools perl-Sys-Mmap vorbis-tools unzip libmysqlclient-devel libgcrypt-devel libgnutls-devel perl-macros fdupes cmake libcurl-devel polkit-devel systemd

%if %{with mp_package}
BuildRequires:  faac libfaad-devel lame xvid xvid-devel Mesa-libGL1

%if 0%{?suse_version} == 1315
BuildRequires:  libavcodec-devel libavdevice-devel libavfilter-devel libavformat-devel libavresample-devel libavutil-devel libpostproc-devel libswresample-devel libswscale-devel

%else
BuildRequires:  ffmpeg libmp4v2-devel libx264-devel libavcodec-3.0-devel libavdevice-3.0-devel libavfilter-3.0-devel libavformat-3.0-devel libavresample-3.0-devel libavutil-3.0-devel libpostproc-3.0-devel libswresample-3.0-devel libswscale-3.0-devel
%endif

%if 0%{?suse_version} > 1201
BuildRequires:  vlc-devel
%else
BuildRequires:  mozilla-js20
%endif

%endif
%{perl_requires}
%{?systemd_requires}
Requires:       apache2 netpbm php5 php5-mbstring apache2-mod_php5 php5-mysql php5-bz2 php5-gd php5-zlib php5-iconv php5-mcrypt php5-sockets mysql perl-Archive-Tar perl-Archive-Zip perl-DBI perl-DBD-mysql perl-Crypt-SSLeay perl-XML-Parser perl-libwww-perl perl-Date-Manip perl-MIME-Lite perl-MIME-tools perl-Sys-Mmap php5-zip zip perl-PHP-Serialization perl-Sys-MemInfo perl-Sys-CPU perl-Data-UUID perl-Class-Std-Fast perl-SOAP-WSDL perl-IO-Socket-Multicast
Requires:       python-zm_database_init >= 2.1.0
Requires(post): permissions
Requires(pre):  shadow
%if %{with mp_package}
Requires:       ffmpeg lame
%endif
Recommends:     perl-Device-SerialPort php5-gd perl-Net-SFTP-Foreign perl-Expect
%if %{with mp_package}
Conflicts:      ZoneMinder
%endif
License:        GPL
Group:          Productivity/Networking/Web/Servers
Summary:        Video camera security and surveillance
Version:        1.30.2
Release:        11.1
Packager:       Monex <monex@liquid-co.de>
URL:            http://www.zoneminder.com/
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source0:        ZoneMinder-%{version}.tar.gz
Source1:        zm.init
Source2:        zm.service
Source3:        cambozola.jar
Source4:        README.cambozola.html
Source5:        LICENSE.cambozola
Source6:        zm.logrotate
Source7:        README.SuSE
Source8:        zm.apache
Source9:        permissions
Source10:       permissions.secure
Source11:       permissions.paranoid
Source12:       MooTools-Core-1.6.0-compat.js
Source13:       LICENSE.mootools
Source14:       zm_tempfiles.conf
Source16:       zoneminder_mysql_settings.cnf
Source17:       crud-3.0.tar.gz
Patch1:         zm.conf.patch
Patch2:         zm_database_default_config.patch
Patch3:         zmpkg_db_init.patch
Patch4:         ignore_signal_on_config_write.patch
Patch5:         reload_config.patch
Patch6:         fix-user-language-path.patch
Patch7:         fix-ZM_VERSION-already-defined-error.patch
Patch8:         allow-setting-date-format-according-to-language.patch
Patch9:         systemd-name-conventions.patch
Patch10:        Fix-montage-view-locale-dateformat.patch

%description
ZoneMinder is a video camera security and surveillance system for linux

Authors:
--------
    Philip Coombes <philip.coombes@zoneminder.com>

%description -l de
ZoneMinder ist eine Video-Überwachungs-Suite für Linux

Authors:
--------
    Philip Coombes <philip.coombes@zoneminder.com>


%debug_package
%prep

%if %{with mp_package}
%setup -q -n ZoneMinder-%{version}
%else
%setup -q
%endif
cp -a %SOURCE4 .
cp -a %SOURCE5 .
cp -a %SOURCE7 .
cp -a %SOURCE10 .
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1

# add ZM_VERSION to config file
cat >> zm.conf.in << EOF

# Current version of ZoneMinder
ZM_VERSION=%{version}

EOF

cd web/api/app/Plugin/Crud/
tar xfvz %SOURCE17

%build
export CFLAGS=$RPM_OPT_FLAGS
export CXXFLAGS=$RPM_OPT_FLAGS

cmake \
  -DZM_DB_HOST=localhost \
  -DZM_DB_NAME=zm \
  -DZM_DB_USER=zm_admin \
  -DZM_RUNDIR=/var/run/zm \
  -DZM_TMPDIR=/tmp \
  -DZM_LOGDIR=/var/log/zm \
  -DZM_MYSQL_ENGINE=InnoDB \
  -DZM_WEBDIR=/srv/www/htdocs/zm/ \
  -DZM_CGIDIR=/srv/www/cgi-bin/ \
  -DZM_LOGDIR=/var/log/zm \
  -DZM_RUNDIR=/var/run/zm \
  -DZM_SOCKDIR=/var/run/zm \
%if %{with mp_package}
  -DZM_NO_FFMPEG=OFF \
%else
  -DZM_NO_FFMPEG=ON \
%endif
  -DENABLE_MMAP=yes \
  -DCMAKE_INSTALL_PREFIX=/usr

%{__make} %{?_smp_mflags}

%install
make DESTDIR=$RPM_BUILD_ROOT install

rm %buildroot/srv/www/htdocs/zm/api/.editorconfig
rm %buildroot/srv/www/htdocs/zm/api/.gitattributes
rm %buildroot/srv/www/htdocs/zm/api/.gitignore

%perl_process_packlist
%perl_gen_filelist
%__install -m 700 -d %buildroot/usr/share/zm/db
%__install -m 600 db/*.sql %buildroot/usr/share/zm/db

# remove installed db files in different location
rm -rf %buildroot/usr/share/zoneminder/

for f in %{_sysconfdir}/logrotate.d %{_sysconfdir}/init.d /usr/sbin %{_sysconfdir}/cron.hourly/ /var/log %{_sysconfdir}/apache2/conf.d %{_sysconfdir}/permissions.d/ /var/run/zm /srv/www/htdocs/zm/temp /srv/www/htdocs/zm/sounds /srv/www/htdocs/zm/images /srv/www/htdocs/zm/events 
do
    %__install -d %buildroot/$f
done
%__install -m 754 %{S:1} %buildroot/%{_sysconfdir}/init.d/zm
%if 0%{?suse_version} >= 1210
  for f in %{_unitdir} /usr/lib/tmpfiles.d
  do
    %__install -d %buildroot/$f
  done

  %__install -m 644 %{S:2} %{buildroot}/%{_unitdir}
  %__install -m 644 %{S:14} %{buildroot}/usr/lib/tmpfiles.d
%if 0%{?suse_version} >= 1310
  %__install -d -m 750 %{buildroot}/%{_sysconfdir}/my.cnf.d/
  %__install -m 640 %{S:16} %{buildroot}/%{_sysconfdir}/my.cnf.d/zoneminder_mysql_settings.cnf
%endif
%endif

ln -s ../../%{_sysconfdir}/init.d/zm %buildroot/usr/sbin/rczm
%__install -m 644 %{S:3} %buildroot/srv/www/htdocs/zm/
%__install -m 775 -d %buildroot/var/log/zm
%__install -m 644 %{S:6} %buildroot/%{_sysconfdir}/logrotate.d/zm
%__install -m 644 %{S:8} %buildroot/%{_sysconfdir}/apache2/conf.d/zm.conf

%__install -m 644 %{S:9} %{buildroot}%{_sysconfdir}/permissions.d/%{name}
%__install -m 644 %{S:9} %{buildroot}%{_sysconfdir}/permissions.d/%{name}.easy

%__install -m 644 %{S:10} %{buildroot}%{_sysconfdir}/permissions.d/%{name}
%__install -m 644 %{S:11} %{buildroot}%{_sysconfdir}/permissions.d/%{name}

%__install -m 644 %{S:12} %buildroot/srv/www/htdocs/zm/mootools.js

echo %version > %buildroot/usr/share/zm/version


%fdupes -s $RPM_BUILD_ROOT/%_mandir
%fdupes $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.files
%defattr(-,root,root)
%dir /usr/share/zm
%dir /usr/share/zm/db
/usr/share/zm/version
/usr/share/zm/db/*.sql
/usr/share/polkit-1/actions/com.zoneminder.systemctl.policy
/usr/share/polkit-1/rules.d/com.zoneminder.systemctl.rules
%{_sysconfdir}/apache2/conf.d/*.conf
/srv/www/htdocs/zm/cambozola.jar
%dir /srv/www/htdocs/zm
%dir /srv/www/htdocs/zm/tools/
%dir /srv/www/htdocs/zm/api
%dir /srv/www/htdocs/zm/ajax
%dir /srv/www/htdocs/zm/css
%dir /srv/www/htdocs/zm/graphics
%dir /srv/www/htdocs/zm/includes
%dir /srv/www/htdocs/zm/js
%dir /srv/www/htdocs/zm/lang
%dir /srv/www/htdocs/zm/skins
%dir /srv/www/htdocs/zm/tools
/srv/www/htdocs/zm/*
/srv/www/cgi-bin/nph-zms
/srv/www/cgi-bin/zms

%if 0%{?suse_version} >= 1210
  %{_unitdir}/*
  /usr/lib/tmpfiles.d/*
%endif

%defattr(-,wwwrun,www)
%dir /srv/www/htdocs/zm/events
%dir /srv/www/htdocs/zm/images
%dir /srv/www/htdocs/zm/sounds
%dir /srv/www/htdocs/zm/temp
%dir /srv/www/htdocs/zm/views
%ghost /var/run/zm

%if 0%{?suse_version} >= 1310
%defattr(-,root,mysql)
%dir %{_sysconfdir}/my.cnf.d/
%config(noreplace) %{_sysconfdir}/my.cnf.d/zoneminder_mysql_settings.cnf
%endif

%defattr(-,root,root)
%_sysconfdir/permissions.d/*
%config(noreplace) %{_sysconfdir}/init.d/zm
%_sbindir/rczm
%{_sysconfdir}/logrotate.d/zm
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README* LICENSE*
%defattr(640,root,www)
%config(noreplace) %{_sysconfdir}/zm.conf
%defattr(-,root,www)
%dir /var/log/zm

%post
/sbin/ldconfig
touch /usr/share/zm/lock
if [ -x /usr/sbin/a2enmod ]; then
  a2enmod -q php5 || a2enmod php5
fi
%restart_on_update apache2

%if 0%{?suse_version} >= 1210
  %service_add_post zm.service
  systemd-tmpfiles --create
%endif

%pre
%if 0%{?suse_version} >= 1230
  /usr/bin/gpasswd -a wwwrun video >/dev/null 2>&1 || :
%else
  /usr/sbin/usermod -A video wwwrun || :
%endif
%if 0%{?suse_version} >= 1210
  %service_add_pre zm.service
%endif

%preun
%stop_on_removal zm
if [ $1 -eq 0 ]; then
    if test -f /usr/share/zm/lock ; then
        rm -f /usr/share/zm/lock
    fi
fi

%if 0%{?suse_version} >= 1210
  %service_del_preun zm.service
%endif

%postun
%insserv_cleanup
/sbin/ldconfig

%if 0%{?suse_version} >= 1210
  %service_del_postun zm.service
%endif

%if %{with mp_package}
%else
%endif
%changelog
* Fri Nov 24 2017 monex@liquid-co.de
- Applay missing patch for ZM_VERSION already defined error.
* Fri Nov 24 2017 monex@liquid-co.de
- Fix missing ZM_VERSION
* Sun Nov 12 2017 monex@liquid-co.de
- Revert last change.
* Sun Nov 12 2017 monex@liquid-co.de
- Removed lame requirements.
* Tue Aug 22 2017 monex@liquid-co.de
- Remove obsolete section.
* Tue Aug 22 2017 monex@liquid-co.de
- Fix security permission problem for events and images.
* Tue Aug 15 2017 monex@liquid-co.de
- Removed obsolete Requires.
* Tue Aug 15 2017 monex@liquid-co.de
- Added missing sources.
* Mon May  1 2017 monex@liquid-co.de
- Updated to version 1.30.2
  See https://github.com/ZoneMinder/ZoneMinder/releases/tag/1.30.2
  for a full description of changes.
- Cleanup of spec file for older discontinued versions.
* Sun Dec 25 2016 monex@liquid-co.de
- Changes for 42.2 packages.
* Wed Aug 24 2016 monex@liquid-co.de
- Eevert last change because it breaks custom states
* Sun Aug 21 2016 monex@liquid-co.de
- Fix web control start/stop/restart
* Thu Aug 18 2016 monex@liquid-co.de
- Fix montage view
* Mon Aug 15 2016 monex@liquid-co.de
- Fix dependencies to ffmpeg
* Sun Aug 14 2016 monex@liquid-co.de
- updated MP requirements for 42.1
* Sat Aug 13 2016 monex@liquid-co.de
- Added perl module dependencies for ONVIF.
* Sun Aug  7 2016 monex@liquid-co.de
- Fix wrong patch due to last change
* Sun Aug  7 2016 monex@liquid-co.de
- Fix order of update execution on startup/shutdown.
* Sun Aug  7 2016 monex@liquid-co.de
- Modified BuildRequired for MP Build
* Sun Aug  7 2016 monex@liquid-co.de
- Fix MP build
- Updated cambozola to latest version.
- Updated mootools to latest version.
* Sat Aug  6 2016 monex@liquid-co.de
- Update to version 1.30.0
  * see https://github.com/ZoneMinder/ZoneMinder/releases/tag/v1.30.0 for changes.
* Sat Mar 12 2016 monex@liquid-co.de
- Updated to version 1.29.0
  * see https://github.com/ZoneMinder/ZoneMinder/releases/tag/v1.29.0 for changes
* Mon Feb 15 2016 monex@liquid-co.de
- Load enable php5 apache module if not already enabled.
* Fri Dec 25 2015 monex@liquid-co.de
- fix patch.
* Fri Dec 25 2015 monex@liquid-co.de
- Chages for new ffmpeg api.
* Fri Dec 11 2015 monex@liquid-co.de
- change requirement for libffmpeg
* Sun Feb 15 2015 monex@liquid-co.de
- update to version 1.28.1
  for full changelog look at https://github.com/ZoneMinder/ZoneMinder/releases/tag/v1.28.1
* Tue Nov  4 2014 monex@liquid-co.de
- update to version 1.28.0
  for full changelog look at https://github.com/ZoneMinder/ZoneMinder/releases/tag/v1.28.0
* Tue Sep 23 2014 monex@liquid-co.de
- force rebuild
* Sun May 25 2014 monex@liquid-co.de
- ignore return value of usermod
* Sun May 25 2014 monex@liquid-co.de
- fix groupadd for suse < 12.3
* Sun May 25 2014 monex@liquid-co.de
- allow to set date format depending on language settings
- add wwrun to group video during installation to avoid
  permission problems
* Sun May 18 2014 monex@liquid-co.de
- added patch to avoid ZM_VERSION already defined php error
* Sun May  4 2014 monex@liquid-co.de
- fix db escapes see http://www.zoneminder.com/forums/viewtopic.php?f=31&t=22196
* Sun May  4 2014 monex@liquid-co.de
- use mb_strtolower when accessing translation files because of
  utf-8 encoding. See http://www.zoneminder.com/forums/viewtopic.php?f=31&t=22195
* Wed Apr 30 2014 monex@liquid-co.de
- added patch which fixes user defined language selection
* Mon Apr 28 2014 monex@liquid-co.de
- added patch to get xml view working again
* Tue Apr 22 2014 monex@liquid-co.de
- use build root when creating mysql config directory
* Tue Apr 22 2014 monex@liquid-co.de
- fix of directory install (used wrong syntax)
* Tue Apr 22 2014 monex@liquid-co.de
- set config no replace option for zm mysql configuration file
* Fri Apr 18 2014 monex@liquid-co.de
- added specialised mysql configuration file for zoneminder
  places in my.cnf.d to disable default sql_mode
* Thu Apr  3 2014 monex@liquid-co.de
- added reload config patch
* Thu Apr  3 2014 monex@liquid-co.de
- add version to config file so that zm_database_init works again
* Wed Apr  2 2014 monex@liquid-co.de
- update to version 1.27.0
  * A new skin!
  * zmcamtool.pl
  * Docker
  * A new camera source type, libvlc.
  * Better RTSP support! This fixed a regression in #221
  * Fixed that annoying bug where you could create zones larger
    than the image they belong to [b368d30]
  * Better WansView camera detection support
* Sun Jan  5 2014 monex@liquid-co.de
- fix ZM_NO_FFMPGEG option
- added patches:
  * fix_ZM_NO_FFMPGEG.patch
- modified patches:
  * fix_perl_install.patch
  * systemd_zm_control.patch
  * zm.conf.patch
  * zm_database_default_config.patch
  * zmpkg_db_init.patch
* Fri Jan  3 2014 monex@liquid-co.de
- update to version 1.26.5
  * Better RTSP support! This fixed a regression in #221
  * Fixed that annoying bug where you could create zones larger
    than the image they belong to [b368d30]
  * Better WansView camera detection support
* Fri Dec  6 2013 monex@liquid-co.de
- add missing dependency
* Fri Dec  6 2013 monex@liquid-co.de
- switch to MMAP and enable it explicit
  (see http://www.zoneminder.com/forums/viewtopic.php?p=82434#p82434)
* Sat Nov 16 2013 monex@liquid-co.de
- don't apply systemd patch for 11.4 builds
* Wed Nov 13 2013 monex@liquid-co.de
- don't call zmupdate.pl during zmpkg.pl
  this is a task of zm_database_init
* Tue Nov 12 2013 monex@liquid-co.de
-  set also ZM_PATH_BUILD to /usr/share/zm with patch
* Tue Nov 12 2013 monex@liquid-co.de
- disable mmap again
* Mon Nov 11 2013 monex@liquid-co.de
- update to ZoneMinder version 1.26.4
* Sun Aug 11 2013 monex@liquid-co.de
- disable mmap because zmtrigger.pl is not working with
  mmap. See
  http://www.zoneminder.com/forums/viewtopic.php?f=29&t=19318&p=76020#p76020
* Sat Aug 10 2013 monex@liquid-co.de
- fix ffmpeg deprecated functions
* Mon Apr 29 2013 monex@liquid-co.de
- added patch from https://bugzilla.redhat.com/show_bug.cgi?id=903063
* Sat Apr 20 2013 monex@liquid-co.de
- delete/insert config within transaction to prevent
  invalid configuration reads by other processes.
- use systemd to start/stop/restart ZoneMinder via webfrontent.
  Using zmpkg.pl from webfrontend confused systemd which then
  showed a wrong state.
  This behaviour is optional so new configuration option under
  in system category was introduced.
* Thu Apr 11 2013 monex@liquid-co.de
- updated systemd unit file to use ZoneMinder PIDFile
  Type is forking now instead of simple
* Fri Mar 29 2013 monex@liquid-co.de
- compile zoneminder with mmap enables
* Tue Mar 12 2013 monex@liquid-co.de
- applied patch for shared memory debug purpose
* Tue Mar 12 2013 monex@liquid-co.de
- use cast instead
* Tue Mar 12 2013 monex@liquid-co.de
- fix compile for 12.3 by using v4l enum type
  found another one
* Tue Mar 12 2013 monex@liquid-co.de
- fix compile for 12.3 by using v4l enum type
* Tue Mar 12 2013 monex@liquid-co.de
- added unified uptime patch to fix uptime output
  in webfrontend
* Sat Mar  9 2013 monex@liquid-co.de
- changed dependency from x264-devel to libx264-devel
* Tue Oct 16 2012 monex@liquid-co.de
- rebuild package due to changed ffmpeg libs
* Tue Sep 11 2012 monex@liquid-co.de
- fix file list
* Tue Sep 11 2012 monex@liquid-co.de
- added use of RPM_OPT_FLAGS
* Tue Sep 11 2012 monex@liquid-co.de
- added fix compile patch for gcc-4.7
* Sun Sep  9 2012 monex@liquid-co.de
- removed unneded BuildRequires
* Sat Aug 11 2012 monex@liquid-co.de
- remove last patch as it is a php configuration issue
* Wed Aug  8 2012 monex@liquid-co.de
- first try to fix hash auth, looking out for a better solution soon
* Sat Jul 28 2012 monex@liquid-co.de
- fix compile with newer ffmpeg versions
* Wed Mar 21 2012 monex@liquid-co.de
- added startup message again
* Wed Mar 21 2012 monex@liquid-co.de
- fixed name in requires: perl-PHP-Serialization
* Tue Mar 20 2012 monex@liquid-co.de
- removed obsolete entries in init file
* Tue Mar 20 2012 monex@liquid-co.de
- added perl-php-serialization to requires so that triggers are working
* Sun Jan  1 2012 monex@liquid-co.de
- corrected last patch
* Sun Jan  1 2012 monex@liquid-co.de
- ignore signals in ConfigAdmin module to prevent Config table corruption
* Sat Dec 31 2011 monex@liquid-co.de
- fix unit file
- don't restart on update beause on systemd it will be double executed which will break
  the configuration table in database
* Fri Dec 30 2011 monex@liquid-co.de
- added restart section to unit file
* Fri Dec 30 2011 monex@liquid-co.de
- disable restart on update as it will break the Config table ind database (why?)
* Fri Dec 30 2011 monex@liquid-co.de
- added automake to build requires
* Fri Dec 30 2011 monex@liquid-co.de
- clean up old changes section
* Fri Dec 30 2011 monex@liquid-co.de
- added missing file
- fix in changelog file
